package Table;

import java.util.ArrayList;

/**
 * This class needs to manage an ArrayList of Entry objects.  It needs a get method that takes a key and returns
 * its corresponding value, or null of the key is not in the arraylist.  It needs a put method that takes a key and value
 * and makes an entry with key, value.  NOTE: There cannot be two entries with the same key.
 * It also needs a remove method which takes a key and, if that key exists in the arraylist, removes that item.
 * Void return on `remove`.
 */
public class Table<K, V> {
    private ArrayList<Entry<K,V>> entries;

    public Table() {
        entries = new ArrayList<Entry<K, V>>();
    }

    public V get(K foo) {
        V value = null;
        for (Entry entry: this.entries) {
            if(entry.getKey().equals(foo)){
                value = (V) entry.getValue();
            }
        }
        return value;
    }


    public void put(K foo, V i) {
        if(this.get(foo) == null){
            Entry<K,V> entry = new Entry<K, V>(foo, i);
            this.entries.add(entry);
        } else {
            for(Entry entry: this.entries){
                if(entry.getKey().equals(foo)){
                    entry.setValue(i);
                    break;
                }
            }
        }
    }

    public void remove(K foo) {
        for (int i = 0; i < this.entries.size(); i++) {
            if(this.entries.get(i).getKey().equals(foo)){
                this.entries.remove(i);
                break;
            }
        }
    }
}
