package TableNested;


import Table.Entry;

import java.util.ArrayList;

/**
 * All you need to do for this microlab is take the Table and Entry from the last one and make Entry a nested class.
 * Think about how nested classes should work with generics.
 */
public class TableNested<K, V> {

    private class Entry<K, V> {
        private K key;


        private V value;

        public Entry(K key, V value) {
            this.key = key;
            this.value = value;
        }

        public K getKey() {
            return key;
        }

        public V getValue() {
            return value;
        }

        public void setValue(V value) {
            this.value = value;
        }
    }

    private ArrayList<Entry<K,V>> entries;

    public TableNested() {
        entries = new ArrayList<Entry<K, V>>();
    }

    public V get(K foo) {
        V value = null;
        for (Entry entry: this.entries) {
            if(entry.getKey().equals(foo)){
                value = (V) entry.getValue();
            }
        }
        return value;
    }

    public void put(K foo, V i) {
        if(this.get(foo) == null){
            Entry<K,V> entry = new Entry<K, V>(foo, i);
            this.entries.add(entry);
        } else {
            for(Entry entry: this.entries){
                if(entry.getKey().equals(foo)){
                    entry.setValue(i);
                    break;
                }
            }
        }
    }

    public void remove(K foo) {
        for (int i = 0; i < this.entries.size(); i++) {
            if(this.entries.get(i).getKey().equals(foo)){
                this.entries.remove(i);
                break;
            }
        }
    }


}
